/* Try to guess the return address in a mail message. */

/* (This is nearly a copy of code inside reply.c.  It is broken out
   so that it can be used by netlibd and because it might be useful
   in other applications. */

/* System V and Version 9 use strchr; BSD uses index.
   The following hack tries to accommodate.  */
#include <sys/param.h>
#include <string.h>
#ifndef CLBYTES
#define index strchr
#define rindex strrchr
#endif

#include <stdio.h>
#define LINESIZE 1026
#define SAME 0
char	line[LINESIZE];    /* raw input line */
char	from[LINESIZE];    /* unfolded from line */
char	address[LINESIZE]; /* return address */


/* like gets(), but safe */
char *
getsn(s,m)
	char *s;
	int m;
{
	if(fgets(s,m,stdin)==NULL)
		return(NULL);
	m = strlen(s)-1;
	if(s[m]=='\n')
		s[m] = '\0';
	return(s);
}


main()
{
	int	inside = 0;
	int	rc;
	char	c, *p, *index();

	while (getsn(line, LINESIZE) != NULL) {
		c = line[0];

		if (inside) { /* unfolding */
			if ( c == ' ' || c == '\t' ) {
				if ( strlen(line) + strlen(from) >= LINESIZE ) {
					fprintf(stderr, "From line too long\n");
					exit(1);
				}
				strcat(from, line);
			} else { /* not a continuation */
				inside = 0;
			}

		} else { /* scanning for new From line */
			if ( c == '\0' ) {
				/* end of mail header */
				break;
			} else if (strncmp("From ", line, 5) == SAME) {
				strcpy(from, line + 5);
				/* chop date */
				p = index(from, ' ');
				if (p)
					*p = '\0';
			} else if (strncmp("From:", line, 5)==SAME) {
				strcpy(from, line + 5);
				inside = 1;
			}
		}
	}

	rc = getfrom(from, address);
	if ( rc != 1 || address[0] == '\0' || unsafe(address) )
		exit(1);
	puts(address);
	exit(0);
}


int
unsafe ( s )
char	*s;
{
	register char	c;
	/* check for characters interpreted by the shell (by which nefarious
           users might otherwise break into the system) */
	for (c = (*s); c != '\0'; c = (*++s)) {
		if ( strchr("\"'`$\n;&|^<>()\\", c) || (c & 0200) )
			return(1);
	}
	return(0);
}


/*
 * EXTRACT SENDER'S ADDRESS OUT OF RFC822 "FROM" LINE
 *  The sender is either the next first whitespace delimited token or
 *  the first thing enclosed in "<" ">".
 *
 *  adapted from /n/bowell/src/cmd/upas (Dave Presotto)
 *  (leading "From: " is already deleted before entry)
 *
 *  modified by Eric Grosse to stop after comma and to allow nested parens
 */
int
getfrom(line, sender)
char	*line, *sender;
{
	int	strncmp();
	char	*lp, *sp;
	int	comment = 0;
	int	anticomment = 0;

	sp = sender;
	for (lp = line; *lp; lp++) {
		if (comment) {
			if (*lp == ')') {
				comment--;
			} else if (*lp == '(') {
				comment++;
			}
			continue;
		}
		if (anticomment) {
			if (*lp == '>')
				break;
		}
		switch (*lp) {
		case '\t':
		case '\n':
			break;
		case ' ':
			if (strncmp(lp, " at ", sizeof(" at ") - 1) == 0 ||
				strncmp(lp, " AT ", sizeof(" AT ") - 1) == 0 ) {
				*sp++ = '@';
				lp += sizeof(" at ") - 2;
			}
			break;
		case '<':
			anticomment = 1;
			sp = sender;
			break;
		case '(':
			comment++;
			break;
		case ',':  /* looks like multiple address; chop */
			*sp++ = '\0';
		default:
			*sp++ = *lp;
			break;
		}
	}
	*sp = '\0';

	return 1;
}


